/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast;

import gluonj.weaver.InternalError;
import gluonj.weaver.JoinPointConstants;

public class AdviceType implements JoinPointConstants {

	private int type;
	
	public static final AdviceType BEFORE = new AdviceType(JoinPointConstants.BEFORE); 
	public static final AdviceType AFTER = new AdviceType(JoinPointConstants.AFTER); 
	public static final AdviceType AROUND = new AdviceType(JoinPointConstants.AROUND); 

	public AdviceType(int t) { 
		type = t;
	}

	public String toString() {

		if (type == JoinPointConstants.BEFORE)
			return "before";
		if (type == JoinPointConstants.AFTER)
			return "after";
		if (type == JoinPointConstants.AROUND)
			return "around";
		throw new InternalError("Unexcepted advice type: " + type);
	}
	
	public int getType() {
	    return type;
	}
	
	public boolean equals(AdviceType adviceType) {
        return type == adviceType.type;
    }
}
