/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast;

import gluonj.ast.java.ASTFormalParameter;
import gluonj.ast.pointcut.ASTPointcutExpr;

import java.util.Iterator;
import java.util.List;

public class PointcutDecl {

	public PointcutDecl(String pcname, List paramList, ASTPointcutExpr expr) {
		name =pcname;
		pointcutParameterList = paramList;
		root = expr;
	}
	
	String name;
	ASTPointcutExpr root;
	List pointcutParameterList; // List<FormalParamter>
	
	public ASTPointcutExpr getPointcut() {
	    return root;
	}
	
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("<pointcut-decl>\n<name>" + name +"</name>\n");
		for (Iterator iter = pointcutParameterList.iterator(); iter.hasNext();) {
			ASTFormalParameter param = (ASTFormalParameter) iter.next();
			buf.append("<param>" + param + "</param>\n");
		}
		buf.append("<expr>" + root + "</expr>\n");
		buf.append("</pointcut-decl>\n");
		return buf.toString();
	}

    public List getParametersList() {
        return pointcutParameterList;
    }

    public String getName() {
        return name;
    }
}
