/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.intertype;

import gluonj.ast.java.ASTField;
import gluonj.ast.joinpoint.JPClass;
import gluonj.ast.joinpoint.JoinPoint;
import javassist.CannotCompileException;
import javassist.ClassPool;
import javassist.CtClass;
import javassist.CtField;
import javassist.NotFoundException;

public class FieldAdditionSig extends ITDeclSig {

    ASTField field;

    public FieldAdditionSig(ASTField f) {
        field = f;
    }

    public void addDeclTo(JoinPoint jp) throws gluonj.weaver.CannotCompileException {
        if (jp.getJPType() == JoinPoint.CLASS) {
            try {
                ClassPool pool = jp.getPool();
                CtClass cc = ((JPClass) jp).getCtClass();
                int modifier = field.getModifier().getModifiers();
                CtClass type = pool.get(field.getType().getType());
                String name = field.getName();

                CtField cf = new CtField(type, name, cc);
                cf.setModifiers(modifier);

                cc.addField(cf, CtField.Initializer.byExpr(field
                        .getInitializer().getExpr()));

            } catch (NotFoundException e) {
                throw new gluonj.weaver.CannotCompileException(e);
            } catch (CannotCompileException e) {
                throw new gluonj.weaver.CannotCompileException(e);
            }

        }
    }
}