/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.intertype;

import gluonj.ast.Import;
import gluonj.ast.java.ASTMember;
import gluonj.ast.joinpoint.JoinPoint;
import gluonj.ast.pcs.PcsType;

/*
 * intertype-declaration := pattern (}ʒuw) member (}tB[hor\bhw)
 */
public class IntertypeDecl {

    private PcsType classPattern;

    private ASTMember member;

    public IntertypeDecl(PcsType pattern, ASTMember m) {
        classPattern = pattern;
        member = m;
    }

    public String toString() {

        StringBuffer str = new StringBuffer();
        str.append("<intertype-decl>\n");
        str.append("<type>" + classPattern + "</type>\n");
        str.append("<decl>" + member + "</decl>\n");
        str.append("</intertype-decl>\n");
        return str.toString();
    }

    public PcsType getClassPattern() {
        return classPattern;
    }

    public ASTMember getMember() {
        return member;
    }

    public IntertypeDeclInfo match(JoinPoint jp) {
        return null;
    }

    public static IntertypeDecl setPackage(IntertypeDecl decl, Import[] impr) {
        decl.imprt = impr;
        return decl;
    }
    
    private Import[] imprt;
    
    public Import[] getImport() {
        return imprt;
    }
}