/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.java;

public class ASTConstructor extends ASTBehavior {

	public ASTConstructor(Modifier m, ASTFormalParameter[] param, ASTType[] th,
			ASTBlock body) {
		super(m, param, th, body);
	}

	public void accept(JavaVisitor v) {
		v.atASTConstructor(this);
	}

	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append(modifier + " new(");
		for (int i = 0; i < parameter.length; i++) {
			buf.append(parameter[i].getType() + " " + parameter[i].getName()
					+ ",");
		}
		buf.append(") throws ");
		for (int i = 0; i < throwable.length; i++) {
			buf.append(throwable[i].getType() + ",");
		}
		buf.append("{" + body + "}\n");
		return buf.toString();
	}
}
