/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.java;


/*
 * type
 * 
 * initializer
 */
public class ASTField extends ASTMember {


	public ASTField(Modifier m, ASTType t, String n, ASTExpr init) {
		super(m);
		type = t;
		name = n;
		initializer = init;
	}

	ASTType type;
	String name;
	ASTExpr initializer;
	
	public void accept(JavaVisitor v) {
		v.atASTField(this);
	}
	
	
	public String getName() {
		return name;
	}

	public ASTType getType() {
		return type;
	}

	public ASTExpr getInitializer() {
		return initializer;
	}

	public String toString() {
		return modifier +" " + type + " " + name + " = " + initializer + ";\n"; 
	}
}
