/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.java;

/*
 * returnType
 */
public class ASTMethod extends ASTBehavior {

	ASTType returnType;

	String name;

	public ASTMethod(Modifier m, ASTType ret, String name,
			ASTFormalParameter[] param, ASTType[] th, ASTBlock body) {
		super(m, param, th, body);
		returnType = ret;
		this.name = name;
	}

	public void accept(JavaVisitor v) {
		v.atASTMethod(this);
	}

	public ASTType getReturnType() {
		return returnType;
	}

	public String getName() {
		return name;
	}

	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append(modifier + " " + returnType + " " + name + "(");
		for (int i = 0; i < parameter.length; i++) {
			buf.append(parameter[i].getType() + " " + parameter[i].getName()
					+ ",");
		}
		buf.append(") throws ");
		for (int i = 0; i < throwable.length; i++) {
			buf.append(throwable[i].getType() + ",");
		}
		buf.append("{" + body + "}\n");

		return buf.toString();
	}

}
