/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.joinpoint;

import javassist.CtBehavior;
import javassist.CtConstructor;
import javassist.CtMember;

public class JPConstructor extends JPBehavior {

    private CtConstructor ccn;

    JPConstructor(CtConstructor c) {
        ccn = c;
    }

    public CtBehavior getCtBehavior() {
        return ccn;
    }

    public CtMember getCtMember() {
        return ccn;
    }

    public CtConstructor getCtConstructor() {
        return ccn;
    }

    public int getJPType() {
        return CONSTRUCTOR;
    }

    public String toString() {
        return ccn.toString();
    }
}
