/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.joinpoint;

import javassist.CtClass;
import javassist.CtConstructor;
import javassist.CtField;
import javassist.CtMethod;
import javassist.expr.FieldAccess;
import javassist.expr.Handler;
import javassist.expr.MethodCall;
import javassist.expr.NewExpr;


public class JPFactory {

    
    public static JoinPoint makeJP(CtClass cc) {
        return new JPClass(cc);
    }
    public static JoinPoint makeJP(CtMethod cm) {
        return new JPMethod(cm);
    }
    public static JoinPoint makeJP(CtField cf) {
        return new JPField(cf);
    }
    public static JoinPoint makeJP(CtConstructor ccn) {
        return new JPConstructor(ccn);
    }
    public static JoinPoint makeJP(MethodCall expr) {
        return new JPMethodCall(expr);
    }
    public static JoinPoint makeJP(FieldAccess expr) {
        return new JPFieldAccess(expr);
    }
    public static JoinPoint makeJP(Handler expr) {
        return new JPHandler(expr);
    }
/*    public static JoinPoint makeJP(Instanceof expr) {
        return new JPInstanceof(expr);
    }
    public static JoinPoint makeJP(NewArray expr) {
        return new JPNewArray(expr);
    }*/
    public static JoinPoint makeJP(NewExpr expr) {
        return new JPNewExpr(expr);
    }
}
