/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.joinpoint;

import javassist.CtBehavior;
import javassist.CtMethod;
import javassist.NotFoundException;
import javassist.expr.Expr;
import javassist.expr.MethodCall;


public class JPMethodCall extends JPExpr {

    private MethodCall expr;
    
    JPMethodCall(MethodCall e) { 
        expr = e;
    }
    
    public Expr getExpr() {
        return expr;
    }
    
    public MethodCall getMethodCall() {
        return expr;
    }
    
    public int getJPType() {
        return METHOD_CALL;
    }
    
    public String toString() {
        try {
        StringBuffer buf = new StringBuffer();
        buf.append(expr.toString());
        CtBehavior where = expr.where();
        CtMethod callee;
            callee = expr.getMethod();
        buf.append("[where= " + where + ",");
        buf.append("callee= " + callee + "]");
        return buf.toString();
        } catch (NotFoundException e) {
            throw new RuntimeException(e);
        }
    }
}
