/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.joinpoint;

import javassist.ClassPool;

public abstract class JoinPoint {

	static public final int CLASS = 1;
	static public final int METHOD = 2;
	static public final int CONSTRUCTOR = 3;
	static public final int FIELD = 4;
	static public final int METHOD_CALL = 5;
	static public final int CAST = 6;
	static public final int FIELD_ACCESS = 7;
	static public final int HANDLER = 8;
	static public final int INSTANCEOF = 9;
	static public final int NEW_ARRAY = 10;
	static public final int NEW_EXPR = 11;
	
	public abstract int getJPType();

	private ClassPool pool;
	
	public void setPool(ClassPool p) {
	    pool = p;
	}
	
	public ClassPool getPool() {
	    return pool;
	}
}
