/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pattern;

public class ArrayTypeNamePattern extends BasicTypeNamePattern {

    BasicTypeNamePattern child;

    public ArrayTypeNamePattern(BasicTypeNamePattern name) {
        child = name;
    }

    public BasicTypeNamePattern getChild() {
        return child;
    }

    public String toString() {
        return child + "[]";
    }

    public String getSoleClassName() {

        return child.getSoleClassName() + "[]";
    }

    public void accept(TypeNamePatternVisitor v) {
        v.atArrayTypeName(this);
    }

    public boolean match(String typename) {
        if (typename.endsWith("[]")) {
            String new_name = typename.substring(0, typename.length() - 2);
            return child.match(new_name);
        } else {
            return false;
        }
    }
}
