/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pattern;

import java.util.regex.Pattern;

/*
 * w肷p^[
 * "*" ܂ނƂ
 */
public class IdPattern {

	String idPat;
	Pattern p;
	
	public IdPattern(String s) {
		idPat = s.replaceAll("\\*", ".*");
	}

	public String getId() {
		return idPat;
	}

	public boolean isSingleIdentifier() {
		return toString().indexOf('*') == -1;
	}

	public boolean match(String typeName) {
		if (p == null) {
			p = Pattern.compile(idPat);
		}
		return p.matcher(typeName).matches();
	}
	
	public String toString() {
		return idPat.replaceAll("\\.\\*", "*");
	}
}
