/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pattern;

import gluonj.weaver.InternalError;

public class IdentifierTypeNamePattern extends SingleTypeNamePattern {

	IdPattern id;

	public IdentifierTypeNamePattern(IdPattern i) {
		id = i;
	}

	public String getSoleClassName() {
		if (!id.isSingleIdentifier()) {
			throw new InternalError("this TypePattern specify classes, not only one class.");
		} else {
			return id.getId();
		}
	}

	public IdPattern getId() {
		return id;
	}

	public String toString() {
		return id.toString();
	}
	
	public void accept(TypeNamePatternVisitor v) {
		v.atIdentifierTypeName(this);
	}
}
