/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pattern;

public class NotTypeNamePattern extends TypeNamePattern {

	public NotTypeNamePattern(TypeNamePattern pattern) {
		child = pattern;
	}

	private TypeNamePattern child;

    public void accept(TypeNamePatternVisitor v) {
		child.accept(v);
		v.atNotTypeTattern(this);
    }
    
    public String toString() {
		return "!" + child;
	}
    
    public boolean match(String typename) {
        return child.match(typename);
    }
}
