/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pattern;

import java.util.regex.Pattern;

public class SingleTypeNamePattern extends BasicTypeNamePattern {

    private String typePat;
    
    public SingleTypeNamePattern(String t) {
        typePat = t;
    }
    SingleTypeNamePattern(){}
    
    public boolean match(String typeName) {
        String pat = getInString();
        return match(typeName, pat);
    }

    public static boolean match(String typeName, String pat) {
        if (pat.equals("*"))
            return true;

        pat = pat.replaceAll("\\*", "[^.]*");
        pat = pat.replaceAll("\\.\\.", "..*.");
        pat = pat.replaceAll("\\.", "\\\\.");

        pat = pat
                .replaceAll("\\\\\\.\\\\\\.\\*\\\\\\.", "(\\\\..*\\\\.|\\\\.)");

        return Pattern.matches(pat, typeName.replace('$', '.'));
    }

    public String getInString() {
        return toString();
    }
    
    public String toString() {
        return typePat;
    }
    
    public String getSoleClassName() {
        return typePat;
    }

    public void accept(TypeNamePatternVisitor v) {
        v.atSingleTypeNamePatttern(this);
    }
}
