/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import gluonj.ast.joinpoint.JoinPoint;



public class PcsAnd extends PcsBinary {

    public PcsAnd(PointcutShadow l, PointcutShadow r) {
        super(l, r);
    }

    public void accept(PcsVisitor v) {
        v.atAnd(this);
    }

    public boolean match(JoinPoint jp) {
        return getLeft().match(jp) && getRight().match(jp);
    }

}
