/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import gluonj.ast.joinpoint.JPConstructor;
import gluonj.ast.joinpoint.JoinPoint;
import javassist.Modifier;

public class PcsConstructor extends PcsBehavior {

    public PcsConstructor(PcsModifier mod, PcsType declaredclass,
            PcsParameter[] param, PcsType[] th) {

        super(mod, declaredclass, param, th);
    }

    PcsConstructor() {
        super();
    }

    public boolean match(JoinPoint jp) {
        if (jp.getJPType() == JoinPoint.CONSTRUCTOR) {
            if (((JPConstructor) jp).getCtConstructor().isClassInitializer()
                    && !modifiers.match(Modifier.STATIC)) {
                return false;
            }
            return super.match(jp);
        } else {
            return false;
        }
    }

    public void accept(PcsVisitor v) {
        v.atConstructorPattern(this);
    }

    public String toString() {
        return modifiers + " " + declaredClass + " .new("
                + listToString(parameter) + ") throws "
                + listToString(throwable);
    }
}