/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import gluonj.ast.joinpoint.JPFieldAccess;
import gluonj.ast.joinpoint.JoinPoint;
import javassist.CtField;
import javassist.NotFoundException;

public abstract class PcsFieldAccess extends PcsExpr {

	public PcsFieldAccess(PcsBehavior where, PcsField field) {
		super(where);
		this.field = field;
	}

	PcsFieldAccess() {
	}

	PcsField field;

	public PcsField getField() {
		return field;
	}

	public boolean match(JoinPoint jp) {
		if (super.match(jp) && (jp.getJPType() == JoinPoint.FIELD_ACCESS)) {
			try {
				CtField cf = ((JPFieldAccess) jp).getFieldAccess().getField();
				return field.match(cf);
			} catch (NotFoundException e) {
				onNotFound(e);
				return false;
			}
		} else {
			return false;
		}
	}
}
