/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import gluonj.ast.joinpoint.JPFieldAccess;
import gluonj.ast.joinpoint.JoinPoint;

public class PcsGet extends PcsFieldAccess {

	public PcsGet(PcsField field) {
		super(PcsBehavior.ANY, field);
	}

	public PcsGet(PcsBehavior where, PcsField field) {
		super(where, field);
	}

	PcsGet() {
	}

	public void accept(PcsVisitor v) {
		v.atGetPattern(this);
	}

	public String toString() {
		return "get(" + field + ")" + "&&" + super.toString();
	}

	public boolean match(JoinPoint jp) {
		if (jp.getJPType() == JoinPoint.FIELD_ACCESS
				&& ((JPFieldAccess) jp).getFieldAccess().isReader()) {
			return super.match(jp);
		}
		return false;
	}

}
