/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import java.lang.reflect.Modifier;

/*
 * Cqw肷p^[\
 * (static || public) && !private
 */
public class PcsModifier {

    static final short ALL_ACCEPT = 0;

    static final short ONLY_TRUE = 1;

    static final short ONLY_FALSE = 2;

    short[] modifierBit = new short[12];

    public void setModifiers(int modId, boolean has) {
        modifierBit[modToIdx(modId)] = has ? ONLY_TRUE : ONLY_FALSE;
    }

    public boolean match(int mod) {

        for (int i = 0; i < modifierBit.length; i++) {

            int j = idxToMod(i);
            boolean b = ((j & mod) == j);
            if ((modifierBit[i] == ONLY_TRUE && !b)
                    || (modifierBit[i] == ONLY_FALSE && b)) {

                return false;
            }
        }
        return true;
    }

    private int modToIdx(int mod) {
        if (mod == 1)
            return 0;
        else
            return 1 + modToIdx(mod / 2);
    }

    private int idxToMod(int idx) {
        if (idx == 0)
            return 1;
        else
            return 2 * idxToMod(idx - 1);
    }

    public String toString() {
        StringBuffer buf = new StringBuffer();

        for (int i = 0; i < modifierBit.length; i++) {
            if (modifierBit[i] == ONLY_TRUE) {
                buf.append(Modifier.toString(idxToMod(i)) + " ");
            } else if (modifierBit[i] == ONLY_FALSE) {
                buf.append("!" + Modifier.toString(idxToMod(i)) + " ");
            }
        }
        return buf.toString();
    }
}