/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import gluonj.ast.joinpoint.JoinPoint;



public class PcsNot extends PointcutShadow {

    PointcutShadow child;

    public PcsNot(PointcutShadow p) {
        child = p;
    }
    
    public void accept(PcsVisitor v) {
        v.atNot(this);
    }

    public PointcutShadow getChild() {
        return child;
    }
    public boolean match(JoinPoint jp) {
        return !child.match(jp);
    }
}
