/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import gluonj.ast.joinpoint.JoinPoint;

public abstract class PointcutResidue {

    public static final PointcutResidue FALSE = new PointcutResidue() {

        public String getStatement(JoinPoint jp) {
            return "";
        }

        public String getDynamicCondition(JoinPoint jp) {
            return "false";
        }
    };

    public static final PointcutResidue TRUE = new PointcutResidue() {

        public String getStatement(JoinPoint jp) {
            return "";
        }

        public String getDynamicCondition(JoinPoint jp) {
            return "true";
        }
    };

    public abstract String getDynamicCondition(JoinPoint jp);

    public abstract String getStatement(JoinPoint jp);
}