/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import gluonj.ast.joinpoint.JoinPoint;
import javassist.NotFoundException;

public abstract class PointcutShadow {

    public static final PointcutShadow TRUE = new PointcutShadow() {

        public void accept(PcsVisitor v) {
        }

        public boolean match(JoinPoint jp) {
            return true;
        }
    };

    public abstract void accept(PcsVisitor v);

    public abstract boolean match(JoinPoint jp);

    protected void onNotFound(NotFoundException e) {
    }
}