/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import gluonj.ast.joinpoint.JoinPoint;

public class Residue {

	private StringBuffer dynamicCondition;
	private StringBuffer statement;

	public Residue() {
		dynamicCondition = new StringBuffer("true");
		statement = new StringBuffer();
	}
	public String getDynamicCondition(JoinPoint jp) {
		return dynamicCondition.toString();
	}

	public String getStatement(JoinPoint jp) {
		return statement.toString();
	}

	public void addDynamicCondition(String s) {
		if (dynamicCondition.toString().equals("")) {
			dynamicCondition.append(s);
		} else {
			dynamicCondition.append("&& " + s);
		}
	}

	public void addStatement(String s) {
		statement.append(s);
	}

	public String toString() {
		return dynamicCondition + ", " + statement;
	}
}
