/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;


public class ASTAnd extends ASTBinaryExpr {

	public ASTAnd(ASTPointcutExpr e1, ASTPointcutExpr e2) {
		this();
		left = e1;
		right = e2;
	}

	public ASTAnd () {
		op = "&&";
	}
	
	public void accept(Visitor v) {

		v.beforeASTAnd(this);
		left.accept(v);
		right.accept(v);
		v.afterASTAnd(this);
	}

	public int getType() {
		return JoinPointConstants.AND;
	}
}
