/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTArgs extends ASTPointcutPrimitive {

	ASTArgs() {
	}

	public ASTArgs(String[] varName, String[] typeName) {
		this.varName = varName;
		param = typeName;
	}

	public ASTArgs(String[] typeName) {
		param = typeName;
	}

	String[] varName;
	String[] param;

	public boolean isBinder() {
		return varName != null;
	}

	public int getType() {
		return JoinPointConstants.ARGS;
	}

	public String[] getTypeName() {
		return param;
	}

	public String[] getVarName() {
		return varName;
	}

	public void accept(Visitor v) {
		v.atASTArgs(this);
	}
	public String toString() {
		if (isBinder()) {
			return "args(" + arrayToStr(getVarName()) + ")";
		} else {
			return "args(" + arrayToStr(getTypeName()) + ")";
		}
	}

	public String arrayToStr(String[] s) {
		StringBuffer buf = new StringBuffer();

		if(s.length > 0) {
			buf.append(s[0]);
		}
		
		for (int i = 1; i < s.length; i++) {
			buf.append("," + s[i]);
		}
		return buf.toString();
	}
}