/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTCflowBelow extends ASTPointcutPrimitive {

	private String cflowID;
	private boolean hasMakedCflowCode;
	private ASTPointcutExpr expr;
	
	public ASTCflowBelow(ASTPointcutExpr expr) {
		this.expr = expr;
	}

	public int getType() {
		return JoinPointConstants.CFLOW_BELOW;
	}

	public void accept(Visitor v) {
		v.atASTCflowBelow(this);
	}

	public ASTPointcutExpr getExpr() {
		return expr;
	}
	public String toString() {
		return "cflow(" + expr.toString() + ")";
	}
}
