/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pcs.PcsField;
import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTFieldSet extends ASTPointcutPrimitive {

    PcsField pattern;

	public ASTFieldSet(PcsField pattern) {
	this.pattern = pattern;     
	}

	public int getType() {
		return JoinPointConstants.FIELD_SET;
	}

	public PcsField getPattern() {
		return pattern;
	}

	public void accept(Visitor v) {
		v.atASTFieldSet(this);
	}

	public String toString() {
		return "set(" + pattern.toString() + ")";
	}

}
