/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pcs.PcsBehavior;
import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTMethodCall extends ASTPointcutPrimitive {

	PcsBehavior pattern;

	public ASTMethodCall(PcsBehavior b) {
	    pattern = b;
	}

	public int getType() {
		return JoinPointConstants.CALL;
	}
	
	public PcsBehavior getPattern() {
	    return pattern;
	}
	public String toString() {

		return "call(" + pattern.toString() + ")";
	}

	public void accept(Visitor v) {
		v.atASTMethodCall(this);
	}
}
