/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pcs.PcsBehavior;
import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTMethodExecution extends ASTPointcutPrimitive {

	ASTMethodExecution() {

	}

	PcsBehavior pattern;

	public ASTMethodExecution(PcsBehavior p) {
		pattern = p;
	}

	public int getType() {
		return JoinPointConstants.EXECUTION;
	}

	public void accept(Visitor v) {
		v.atASTMethodExecution(this);
	}

	public PcsBehavior getPattern() {
		return pattern;
	}

	public void setPattern(PcsBehavior pattern) {
		this.pattern = pattern;
	}

	public String toString() {
		return "execution(" + pattern.toString() + ")";
	}
}
