/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;


public class ASTNot extends ASTUnaryExpr {

	ASTPointcutExpr child;

	public ASTNot(ASTPointcutExpr expr) {
		child = expr;	
	}
	
	public void accept(Visitor v) {

		v.beforeASTNot(this);
		child.accept(v);
		v.afterASTNot(this);
	}
	public ASTPointcutExpr getChild() {
		return child;
	}
	
	public String toString() {
		return "!(" + child.toString()+ ")"; 
	}
	public int getType() {
		return JoinPointConstants.NOT;
	}

}
