/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;


public class ASTOr extends ASTBinaryExpr {

	public ASTOr() {
		op = "||";
	}
	public ASTOr(ASTPointcutExpr l, ASTPointcutExpr r) {
		this();
		left = l;
		right = r;
	}
	public int getType() {
		return JoinPointConstants.OR;
	}

	public void accept(Visitor v) {

		v.beforeASTOr(this);
		left.accept(v);
		right.accept(v);
		v.afterASTOr(this);
	}

}
