/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTPCReference extends ASTPointcutPrimitive {
	
	String name;
	String[] arguments = new String[]{};
	
	public ASTPCReference(String n, String[] args) {
	    name = n;
	    arguments = args;
	}

	public int getType() {
		return JoinPointConstants.REFERENCE;
	}

	public void accept(Visitor v) {
		v.atASTPCReference(this);
	}
	
	public String getName() {
		return name;
	}

	public String[] getArguments() {
		return arguments;
	}
	public String toString() {
		StringBuffer str = new StringBuffer(name + "(");
		for (int i = 0; i < arguments.length; i++) {
			str.append(arguments[i] + ",");
		}
		return str.toString() + ")";
	}
}
