/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pcs.Residue;
import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTResidue extends ASTPointcutPrimitive {

	private Residue residue;

	public ASTResidue(Residue r) {
		residue = r;
	}

	public void accept(Visitor v) {
		v.atASTResidue(this);
	}

	public int getType() {
		return JoinPointConstants.RESIDUE;
	}

	public String toString() {
		return "residue(" + residue + ")";
	}

	public Residue getResidue() {
		return residue;
	}
}
