/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pcs.PointcutShadow;
import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;


public class ASTShadow extends ASTPointcutPrimitive {

	PointcutShadow shadow;

	public ASTShadow(PointcutShadow s) {
		shadow = s;
	}
	
	public PointcutShadow getShadow() {
		return shadow;
	}

	public int getType() {
		return JoinPointConstants.SHADOW;
	}

	public String toString() {
		return "shadow(" + shadow + ")";
	}
	public void accept(Visitor v) {
        v.atASTShadow(this);
    }

}
