/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTTarget extends ASTPointcutPrimitive {

	String varName;
	String typeName;
	
	public ASTTarget(String type) {
			typeName = type;
	}
	
	public ASTTarget(String name, String type) {
	    typeName = type;
	    varName = name;
	}
	
	public boolean isBinder() {
		return varName != null && varName != "";
	}

	public int getType() {
		return JoinPointConstants.TARGET;
	}

	public String getTypeName() {
		return typeName;
	}

	public String getVarName() {
		return varName;
	}

	public void accept(Visitor v) {
		v.atASTTarget(this);
	}
	public String toString() {
		if(isBinder()) {
			return "target(" + getVarName() +")";
		} else {
			return "target(" + getTypeName() +")";
		}
	}
}