/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTThis extends ASTPointcutPrimitive {

	String varName;
	String typeName;
	

	public ASTThis(String name, String type) {
		
	    varName = name;
	    typeName = type;
    }

    public ASTThis(String name) {
        typeName = name;
    }

    public boolean isBinder() {
		return varName != null && varName != "";
	}

	public int getType() {
		return JoinPointConstants.THIS;
	}

	public String getTypeName() {
		return typeName;
	}

	public String getVarName() {
		return varName;
	}

	public void accept(Visitor v) {
		v.atASTThis(this);
	}
	public String toString() {
		if(isBinder()) {
			return "this(" + getVarName() +")";
		} else {
			return "this(" + getTypeName() +")";
		}
	}
}