/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pcs.PcsType;
import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;

public class ASTWithin extends ASTPointcutPrimitive {

	PcsType pattern;

	public ASTWithin(PcsType pattern) {
		this.pattern = pattern;
	}

	public int getType() {
		return JoinPointConstants.WITHIN;
	}

	public PcsType getPattern() {
		return pattern;
	}

	public void accept(Visitor v) {
		v.atASTWithin(this);
	}
	public String toString() {
		return "within(" + pattern.toString() +")";
	}
}
