/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut;

import gluonj.ast.pcs.PcsBehavior;
import gluonj.ast.pointcut.visitor.Visitor;
import gluonj.weaver.JoinPointConstants;



public class ASTWithincode extends ASTPointcutPrimitive {

    PcsBehavior pattern;
    
    public ASTWithincode(PcsBehavior p) {
        pattern = p;
    }
    
    public String toString() {
        return "withincode(" + pattern.toString() +")";
    }
    public int getType() {
        return JoinPointConstants.WITHINCODE;
    }
    
    public void accept(Visitor v) {
        v.atASTWithincode(this);
    }
    
    public PcsBehavior getPattern() {
        return pattern;
    }
}
