/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pointcut.visitor;

import gluonj.ast.pointcut.ASTPointcutExpr;
import gluonj.ast.pointcut.PointcutExprUtil;

import java.util.LinkedList;
import java.util.List;

public abstract class DNFTranslator extends DNFVisitor {

    /**
     * 
     * @param exprs -
     *            means the elements which one conjunctive normal form (CNF)
     *            contains. The type of exprs is List <AstPointcutUnary>.
     * 
     * @return The list of CNF which is replaced exprs to.
     */
    public abstract List[] translateCNF(List exprs);

    private List cnfs = new LinkedList();

    public void atConjunctive(List exprs) {
        List[] result = translateCNF(exprs);
        for (int i = 0; i < result.length; i++) {
            cnfs.add(result[i]);
        }
    }
    
    public ASTPointcutExpr getDNF() {
        return PointcutExprUtil.makeDisjunctive(cnfs);
    }
}
