/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.runtime;

import java.util.HashMap;
import java.util.Map;

public class CflowCounter {

    static private Map flagMap = new HashMap();

    static public boolean isIn(int flagid) {
        int val = getVal(flagid);
        return val > 0;
    }

    static public void enter(int flagid) {
        int val = getVal(flagid);
        flagMap.put(new Integer(flagid), new Integer(val + 1));
    }

    static public void getout(int flagid) {
        int val = getVal(flagid);
        flagMap.put(new Integer(flagid), new Integer(val - 1));
    }

    static private int getVal(int flagid) {
        int val = 0;
        if (flagMap.containsKey(new Integer(flagid))) {
            val = ((Integer) flagMap.get(new Integer(flagid))).intValue();
        }
        return val;
    }
}