/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.runtime;

public abstract class Closure {

	protected Object thisObject;
	protected Object[] args;
	
	public Closure() {
	}

	public Object proceed() throws Throwable {
	    return proceed(thisObject, args);
	}
	
	public Object proceed(Object t) throws Throwable {
	    return proceed(t, args);
	}
	
	public Object proceed(Object[] arg) throws Throwable {
	    return proceed(thisObject, arg);
	}
	
	public abstract Object proceed(Object t, Object[] arg) throws Throwable;

	public void setArguments(Object[] args) {
		this.args = args; 
	}
	
	public void setThisObject(Object thisObj) {
		thisObject = thisObj;
	}
}
