/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.weaver.gen;

import gluonj.ast.Advice;
import gluonj.ast.Aspect;
import gluonj.ast.Import;
import gluonj.ast.intertype.IntertypeDecl;
import gluonj.weaver.CannotCompileException;

public class ImportApplier extends AbstractProcessor {

    private Import[] currentImport;

    protected Aspect process(Aspect aspect) throws CannotCompileException {

        currentImport = aspect.getImport();
        IntertypeDecl[] decl = aspect.getIntertypeDecl();
        for (int i = 0; i < decl.length; i++) {
            decl[i] = IntertypeDecl.setPackage(decl[i], currentImport);
        }
        aspect.replaceIntertypeDeclWith(decl);
        return super.process(aspect);
    }

    protected Advice process(Advice advice) throws CannotCompileException {

        advice = Advice.setPackage(advice, currentImport);

        return advice;
    }

}
