/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.ast.pcs;

import java.lang.reflect.Modifier;

import junit.framework.TestCase;

public class TestModifierPattern extends TestCase {

	public final void test() {
		assertTrue(test1());
		assertFalse(test2());
	}

	/*
	 * pattern: public && !abstract
	 * target: public static
	 */
	public boolean test1() {
		PcsModifier p = new PcsModifier();
		p.setModifiers(Modifier.PUBLIC, true);
		p.setModifiers(Modifier.ABSTRACT, false);
		return p.match(Modifier.PUBLIC | Modifier.STATIC);
	}
	/*
	 * pattern !static && strict
	 * target strict static
	 */
	public boolean test2() {
	    
		PcsModifier p = new PcsModifier();
		p.setModifiers(Modifier.STATIC, true);
		p.setModifiers(Modifier.STRICT, false);
		return p.match(Modifier.STRICT | Modifier.STATIC);
	}
}
