/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.test;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class Runner {

    public static void main(String[] args) throws IllegalArgumentException,
            SecurityException, ClassNotFoundException,
            InvocationTargetException, IllegalAccessException,
            InstantiationException, NoSuchFieldException {

        new Runner().doMain(args);
    }

    public void doMain(String[] args) throws ClassNotFoundException,
            InvocationTargetException, IllegalArgumentException,
            SecurityException, IllegalAccessException, InstantiationException,
            NoSuchFieldException {

        try {
            if (args.length == 2) {
                String className = args[0];
                String methodName = args[1];

                Class c = Class.forName(className);
                Method[] ms = c.getDeclaredMethods();

                for (int i = 0; i < ms.length; i++) {
                    if (ms[i].getName().equals(methodName)) {
                        invoke(ms[i], c);
                        return;
                    }
                }
            }
        } catch (InvocationTargetException e) {
            if (e.getCause() instanceof RuntimeException) {
                throw (RuntimeException) e.getCause();
            } else {
                throw e;
            }
        }

        StringBuffer buf = new StringBuffer();
        for (int i = 0; i < args.length; i++) {
            buf.append(args[i] + ",");
        }
        throw new RuntimeException("Argument is wrong : " + buf.toString());
    }

    protected void invoke(Method method, Class cls)
            throws IllegalArgumentException, IllegalAccessException,
            InvocationTargetException, InstantiationException,
            SecurityException, NoSuchFieldException {
        if (method.getParameterTypes().length == 0) {
            method.invoke(cls.newInstance(), new Object[0]);
            return;
        }
    }
}