/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.test.dyn;

public class Main extends ParentMain {


    public static void main(String[] args) {

        ParentMain m = new Main();
        m.doMain(m); // target && this && args
		if (m.exec == 7 && m.call == 7 && m.set == 1 && m.get == 1) {
		} else {
			throw new RuntimeException("assertion error:" + "exec = " + m.exec
					+ "call = " + m.call + "set = " + m.set + "get = " + m.get);
		}

		m = new Main();
		ParentMain m2 = new ParentMain();
	
		m.doMain(m2); // target && this && !args
		if (m.exec == 7 && m.call == 7 && m.set == 1 && m.get == 1) {
		} else {
			throw new RuntimeException("assertion error:" + "exec = " + m.exec
					+ "call = " + m.call + "set = " + m.set + "get = " + m.get);
		}
 		m = new Main();
 		m2 = new ParentMain();
		m2.callMainOf(m); // !this && target && args
		if (m.call != 7) {
			throw new RuntimeException("assertion error:" + "call = " + m.call);
		}

		m2 = new ParentMain();
		m2.callMain(m2); // !this && !target && !args
		if (m2.call != 7) {
			throw new RuntimeException("assertion error:" + "call = " + m.call);
		}
		
		m = new Main();
		m2 = new ParentMain();
		m.callMainOf(m2); // this && !target && !args 
		if (m.call != 7) {
			throw new RuntimeException("assertion error:" + "call = " + m.call);
		}
    }

    void doMain(ParentMain m) {
        //before exec: this.exec += 1; target.exec += 2;
        //args[0].exec += 4;

        i = 1;
        //after set: target.set +=1;
        empty(m);
        //after call(empty()) : target.call +=1 ; this.call += 2;
        // args[0].call += 4;

        //before get: this.get += 1;
        j = i;
    }
    
}

class ParentMain {
	int i;

	int j;

	int k;

	int exec;

	int set;

	int call;

	int get;
	void doMain(ParentMain m) {
		//before exec: this.exec += 1; target.exec += 2;
		//args[0].exec += 4;

		i = 1;
		//after set: target.set +=1;
		empty(m);
		//after call(empty()) : target.call +=1 ; this.call += 2;
		// args[0].call += 4;

		//before get: this.get += 1;
		j = i;
	}
    
	void callMain(ParentMain m) {
		empty(m);
	}
	void callMainOf(ParentMain m) {
		m.empty(m);
	}

	void empty(ParentMain m) {
	}
}
