/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.test.typepat;

public class Main {

	public static void main(String[] args) {

		Main m = new Main();
		m.doMain(m);
	}

	int array1;
	int array2;
	int any;
	int sub1;
	int sub2;
	int sub3;

	void doMain(Main m) {
		
		testArray1(m);
		testArray1(new Main[] { m });
		testArray2(new Main[] { m });
		testAny(0);
		testAny(null);
		testSub(new Object());
		testSub(new MyService());
		testSub(new MyServiceChild());

		boolean b =
			array1 == 1
				&& array2 == 1
				&& any == 2
				&& sub1 == 3
				&& sub2 == 2
				&& sub3 == 1;

		if (!b) {
			throw new RuntimeException(
				"array1 = "
					+ array1
					+ ",array2 = "
					+ array2
					+ ",any = "
					+ any
					+ ",sub1 = "
					+ sub1
					+ ",sub2 = "
					+ sub2
					+ ", sub3 = "
					+ sub3);
		}
	}

	Object[] testArray1(Main m) {
		//x execution(Object[] gluonj.*test..testArray*(gluonj.*.typepat.Main[]))
		//x execution(Object[][][] gluonj.*test..testArray*(gluonj.*.typepat.Main[]))
		return null;
	}
	Object[] testArray1(Main[] m) {
		// execution(Object[] gluonj.*test..testArray*(gluonj.*.typepat.Main[]))
		// array1 += 1;
		//x execution(Object[][][] gluonj.*test..testArray*(gluonj.*.typepat.Main[]))
		return null;
	}

	Object[][][] testArray2(Main[] m) {
		//x execution(Object[] gluonj.*test..testArray*(gluonj.*.typepat.Main[]))
		// execution(Object[][][] gluonj.*test..testArray*(gluonj.*.typepat.Main[]))
		// array2 += 1;
		return null;
	}

	void testAny(int i) {
		// execution(void gluonj..Main.testAny(*))
		// any += 1;
	}
	void testAny(String s) {
		// execution(void gluonj..Main.testAny(*))
		// any += 1;
	}

	void testSub(Object o) {
		// execution(void gluonj.*.Main.testSub(Object+))
		// sub1 += 1;  
		// x execution(void gluonj.*.Main.testSub(gluonj..MyService+))  
		// x execution(void gluonj.*.Main.testSub(gluonj..MyServiceChild+))  
	}
	void testSub(MyService m) {
		// execution(void gluonj.*.Main.testSub(Object+))  
		// sub1 += 1;  
		// execution(void gluonj.*.Main.testSub(gluonj..MyService+))  
		// sub2 += 1;  
		// x execution(void gluonj.*.Main.testSub(gluonj..MyServiceChild+))  
	}
	void testSub(MyServiceChild c) {
		// execution(void gluonj.*.Main.testSub(Object+))  
		// sub1 += 1;  
		// execution(void gluonj.*.Main.testSub(gluonj..MyService+))  
		// sub2 += 1;  
		// execution(void gluonj.*.Main.testSub(gluonj..MyServiceChild+))  
		// sub3 += 1;  
	}

	static public class MyServiceChild extends MyService {

	}
}
