/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package gluonj.weaver;

import gluonj.ast.pattern.SingleTypeNamePattern;
import junit.framework.TestCase;

public class TestTypeNameSpecifyVisitor2 extends TestCase {

    public final void testAsterisk() {
        String t = "gluonj.weaver.test";
        
        boolean b1 = SingleTypeNamePattern.match(t, "gluon*.weaver.*");
        boolean b2 = SingleTypeNamePattern.match(t, "*on*.*weaver.*");
        boolean n_b1 = SingleTypeNamePattern.match(t, "gluonj*weaver.tes");
        boolean n_b2 = SingleTypeNamePattern.match(t, "*.weavers.*s");

        assertTrue(b1);
        assertTrue(b2);
        assertFalse(n_b1);
        assertFalse(n_b2);
    }

    public final void testDotDot() {

        String t =  "gluonj.weaver.test";

        boolean b1 = SingleTypeNamePattern.match(t, "gluonj..test");
        boolean b2 = SingleTypeNamePattern.match(t, "glu*..*t");
        boolean b3 = SingleTypeNamePattern.match(t, "gluonj..weaver.test");
        boolean n_b1 = SingleTypeNamePattern.match(t, "gluonj..est");
        boolean n_b2 = SingleTypeNamePattern.match(t, "gluon..*st");

        assertTrue(b1);
        assertTrue(b2);
        assertTrue(b3);
        assertFalse(n_b1);
        assertFalse(n_b2);
    }
}
