/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package test;

import javassist.CannotCompileException;
import javassist.ClassPool;
import javassist.CtClass;
import javassist.Loader;
import javassist.LoaderClassPath;
import javassist.NotFoundException;
import javassist.Translator;
import junit.framework.TestCase;

/*
 * ꂼeXg\bhňقȂClassPool gɂ́B 
 */
public class TestPool extends TestCase {

    public void tPoolAndLoader() throws Throwable {

        ClassPool cp = ClassPool.getDefault();
        ClassLoader cl = ClassLoader.getSystemClassLoader();

/*        ClassLoader cl1 = new ClassLoader(cl) {
        };
        ClassLoader cl2 = new ClassLoader(cl) {
        };
  */      
        ClassPool cp1 = new ClassPool();
        cp1.appendClassPath(new LoaderClassPath(cl));
        ClassPool cp2 = new ClassPool();
        cp2.appendClassPath(new LoaderClassPath(cl));

        Loader l1 = new Loader(cp1);
        Loader l2 = new Loader(cp2);

        l1.addTranslator(cp1, new Translator() {
            public void onLoad(ClassPool cp, String name)
                    throws NotFoundException, CannotCompileException {
                if (name.equals("test.Foo")) {
                    CtClass cc = cp.get(name);
                    cc.getDeclaredMethod("foo").insertBefore(
                            "System.out.println(\"1\");");
                }
            }

            public void start(ClassPool arg0) throws NotFoundException,
                    CannotCompileException {
            }
        });

        l2.addTranslator(cp2, new Translator() {
            public void onLoad(ClassPool cp, String name)
                    throws NotFoundException, CannotCompileException {
                if (name.equals("test.Foo")) {
                    CtClass cc = cp.get(name);
                    cc.getDeclaredMethod("foo").insertBefore(
                            "System.out.println(\"2\");");
                }
            }
            public void start(ClassPool arg0) throws NotFoundException,
                    CannotCompileException {
            }
        });

        l1.run("test.Foo", new String[0]);
        l2.run("test.Foo", new String[0]);
    }
}
