/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package test.packageimport;

public class Main {

    private int value = 0;

    public void testPC() {
        Counter c = new Counter();
        int i = c.count(value);
        value = value + i;
        if (value != 2) {
            System.out.println(value);
            throw new RuntimeException(
                    "Package import does not work correctly.");
        }
    }

    public void testPC2() {
        test.packageimport.foo.Counter c1;
        test.packageimport.foo2.Counter c2;
        test.packageimport.foo.bar.Counter c3;

        c1 = new test.packageimport.foo.Counter();
        c2 = new test.packageimport.foo2.Counter();
        c3 = new test.packageimport.foo.bar.Counter();

        c1.count(0);
        c2.count(0);
        c3.count(0);

        if (value != 3) {
            throw new RuntimeException(
                    "Package import does not work correctly.");
        }
    }

    public void testAdv() {
        Counter c = new Counter();
        value = c.count(0);
        if (value != 2) {
            System.out.println(value);
            throw new RuntimeException(
                    "Package import does not work correctly.");
        }
    }
    
    public void testITD() {
        
        Counter c = new Counter();
        c.count(3);
        c.count(4);
        c.count(5);
        
        rollback(c);
        
        int i = c.count(6);
        
        if (i != 9) {
            System.out.println(value);
            throw new RuntimeException(
                    "Package import does not work correctly in reference tag.");
        }
    }

    private void rollback(Counter c) {
    }
}