/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package test.pc.shadow;

import test.GluonJTestCase;

public class ShadowTest extends GluonJTestCase {

    private String packageName = "test.pc.shadow";

    private String className = "Main";

    public final void testBeforeExecution() throws Throwable {
        runOnGluonJ(className, getTestingMethod(),
                new String[] { "execution.xml" });
    }

    public final void testBeforeCall() throws Throwable {
        runOnGluonJ(className, getTestingMethod(), new String[] { "call.xml" });
    }

    public final void testBeforeSet() throws Throwable {
        runOnGluonJ(className, getTestingMethod(), new String[] { "set.xml" });
    }

    public final void testBeforeGet() throws Throwable {
        runOnGluonJ(className, getTestingMethod(), new String[] { "get.xml" });
    }

    public final void testAroundExecution() throws Throwable {
        runOnGluonJ(className, getTestingMethod(),
                new String[] { "around_execution.xml" });
    }

    public final void testAroundCall() throws Throwable {
        runOnGluonJ(className, getTestingMethod(),
                new String[] { "around_call.xml" });
    }

    public final void testAroundSet() throws Throwable {
        runOnGluonJ(className, getTestingMethod(),
                new String[] { "around_set.xml" });
    }

    public final void testAroundGet() throws Throwable {
        runOnGluonJ(className, getTestingMethod(),
                new String[] { "around_get.xml" });
    }
}