/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package test.reflect;

import gluonj.runtime.Aspect;

import java.util.logging.Logger;

public class Main {

    public boolean isWeaved;

    public void testReflect() {

        Logger logger = Logger.getAnonymousLogger();

        if (Aspect.get(this, Logger.class) != null) {
            throw new RuntimeException("Anonymous field refers to non null object.");
        }
        Aspect.add(this, logger, Logger.class);
        if (Aspect.get(this, Logger.class) == null) {
            throw new RuntimeException("Aspect.add() does not work correctly.");
        }
        Aspect.remove(this, logger, Logger.class);
        if (Aspect.get(this, Logger.class) != null) {
            throw new RuntimeException("Aspect.remove() does not work correctly.");
        }
    }
}