/*
 * GluonJ 2005, an aspect-oriented system for Java.
 * Copyright (C) 2006 Rei Ishikawa.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 */
package test.weaver;

import java.io.File;

import test.GluonJTestCase;
import gluonj.ui.StaticWeaver;

public class StaticWeaverTest extends GluonJTestCase {

    /*
     * -srcdir -includes -destdir
     */
    public void test() throws Throwable {
        StaticWeaver.weave(new String[0]);
        String cmd = "-classdir ./bin/ " + "-includes test/weaver/* "
                + "-destdir ./temp/output/ " + TESTDIR
                + "\\test\\weaver\\aop.xml";
        StaticWeaver.weave(cmd.split(" "));

        String[] path = new String[] {
                "./temp/output/test/weaver/A.class",
                "./temp/output/test/weaver/StaticWeaverTest.class", };
        for (int i = 0; i < path.length; i++) {
            File f = new File(path[i].replace('/', File.separatorChar));
            assertTrue(f.exists());
        }
    }

    /*
     * -srcdir -includes -classpath -destdir
     */
    public void testClasspathOpt() throws Throwable {

        String jar = TESTDIR + "/test/weaver/counter.jar";
        jar = jar.replace('/', File.separatorChar);

        String cmd = "-classdir ./bin/ " + "-includes test/weaver/**/A "
                + "-destdir ./temp/output/ " + "-classpath " + jar + " "
                + ".\\test\\test\\weaver\\aop_cp.xml";
        StaticWeaver.weave(cmd.split(" "));

        String[] path = new String[] {
                "./temp/output/test/weaver/A.class",
                "./temp/output/test/weaver/foo/A.class", };
        for (int i = 0; i < path.length; i++) {
            File f = new File(path[i].replace('/', File.separatorChar));
            assertTrue(f.exists());
        }
    }

    /*
     * -injar -includes -outjar
     */
    public void testJarOpt() throws Throwable {

        String jar = TESTDIR + "/test/weaver/counter.jar";
        jar = jar.replace('/', File.separatorChar);

        String cmd = "-injar " + jar + " " + "-includes test/weaver/* "
                + "-outjar ./temp/output/counter_new.jar "
                + ".\\test\\test\\weaver\\aop.xml";
        StaticWeaver.weave(cmd.split(" "));

        String[] path = new String[] { "./temp/output/counter_new.jar", };
        for (int i = 0; i < path.length; i++) {
            File f = new File(path[i].replace('/', File.separatorChar));
            assertTrue(f.exists());
        }
    }
}
